<?php
/*
noCopyright(C) 程式設計 台中縣網 張本和 axer@ms1.boe.tcc.edu.tw 981006-08
版權宣告：無，歡迎修改使用。

*/

class Base_class {
    var $Session = null;    //全站Session
    var $DB;                //資料庫物件
	var $SCHS_PER_ROW=10;
	var $DOMAIN="";	//網域 

    // 屬性部分函式
    // ---------------------------------------------------
    // 設定Session至物件變數中，因樣版會取出需用Session的值
    public function SetSession($s){ $this->Session = $s; }
    public function GetSession($item){
        if(!empty( $this->Session[$item]) )return $this->Session[$item];
        return -1;
    }

    public function SetCurrParam($s){ $this->CurrParam = $s; }
    private function GetCurrParam(){return $this->CurrParam; }

    public function GetCheckCountByState($st){
      $sql ="select count(`sn`) as `cnt` from `checkrec` where `state` ={$st}";
      return $this->DB->GetOne( $sql );

    }

    public function GetRegSchText(){
		$sch=(int)$this->SCHS_PER_ROW;
		if( $sch == 0)return "";
		$sql ="select * from addr where LENGTH(`recIP`)>0 order by `recDT` DESC";
		$arr = $this->DB->GetAll( $sql );
		$alen = sizeof( $arr);
		$res= "";
		
		for( $ii=0; $ii< $alen; $ii++){
			$res .= "<a href='#' class='title' title='<small>{$arr[$ii]['schname']}第 {$arr[$ii]['count']}  次造訪</small>|<small>{$arr[$ii]['recDT']} From {$arr[$ii]['recIP']}</small>'>{$arr[$ii]['schname']}</a> ";
			if( $sch > 0)
				if( $ii % $sch== ($sch-1))$res .= "<BR>"; 
		}
		return $res;
	}

    public function GetSchNameByIP6( $ip6 ){
        $sql ="select * from addr where `prefix` ='{$ip6}'";
        $arr = $this->DB->GetRow( $sql );
        return $arr;
    }

    public function GetSchNameByIP6_( $ip6 ){
		$o = new ipv6();
        $sql ="select * from `addr`";
        $arr = $this->DB->GetAll( $sql );
		foreach($arr as $unit)
			if( $o->matchCIDR6( $unit['prefix'], $ip6) )return $unit;
        return false;
    }

    public function ProcClickCount($sn){
      $sql =  "update `checkrec` set `clicked`=`clicked`+1 where `sn`={$sn} Limit 1";
      $this->DB->Execute( $sql );
	  return 1;
    }

    public function ProcSaveIP6Count($arr, $logeachIP6=0 ){
		if( $logeachIP6 == 1){
	        $sql ="select `recIP` from `rec` where `recIP` ='{$arr['recIP']}'";
	        $one = $this->DB->GetOne( $sql );
			if( !$one){ 
				$sql= "insert into `rec` (`recIP`,`createdDT`) values ( '{$arr['recIP']}', now())";
		        $IsOk= $this->DB->Execute( $sql );
	            if( ! $IsOk) return -1;
	            $sql ="update addr set `count`=`count`+1  where `sID`='{$arr['sID']}'";
    	        $IsOk= $this->DB->Execute( $sql );
        	    if( ! $IsOk) return -2;
			}
		}
		else{
	        $sql ="update addr set `count`=`count`+1  where `sID`='{$arr['sID']}'";
    	    $IsOk= $this->DB->Execute( $sql );
        	if( ! $IsOk) return -3;
		}
        return 1;
    }

    public function ProcSaveIP6Rec($arr ){
        $sql ="update addr set `count`=1, `recDT`=NOW(), `recIP`='{$arr['recIP']}'  where `sID`='{$arr['sID']}'";
        $IsOk= $this->DB->Execute( $sql );
        if( ! $IsOk) return -1;
        return 1;
	}

    public function ProduIPv6EnableList(){
      $n=  $this->SCHS_PER_ROW;
      $sql ="select * from `checkrec` where `state`>0 order by `updateDT` DESC";
	  return $this->DB->GetAll( $sql );
    }

    public function SaveIPv6CheckRec($hn, $IsOk, $arr){
      $sql ="select `sn` from `checkrec` where `hostname` ='{$hn}'";
      $one = $this->DB->GetOne( $sql );
	  if($IsOk>0 && $arr[1]!=-1)$title =$arr[1];
	  else $title="";
      if( !$one){
        $sql= "insert into `checkrec` (`hostname`,`title`,`state`,`updateDT`, `createdDT`) values ( '{$hn}','{$title}', {$IsOk}, now(), now())";
      }else{
        $sql= "update `checkrec` set `state`={$IsOk}, `updateDT`=now(),`title`='{$title}' where `sn`={$one}";
      }
      $IsOk= $this->DB->Execute( $sql );
      if( ! $IsOk) return -1;
      return 1;
    }
}

/**
*   ipv6 class by axer@ms1.boe.tcc.edu.tw
*/
class ipv6{
    /**
    *   ExpandIPv6Notation2Bin()-  Convert an ipv6 address to bin string
    *   @param string $ip6 - an ipv6 address
    *   @return return the binary string of an ipv6 address if parameter ip6 is an ipv6 address,
    *           else it return an empty string.
    */
    public function ExpandIPv6Notation2Bin($ip6) {
        if (strpos($ip6, '::') !== false)
            $ip6 = str_replace('::', str_repeat(':0', 8 - substr_count($ip6, ':')).':', $ip6);
        $ip6parts = explode(':', $ip6);
        $res="";
        foreach ($ip6parts as $part)
            $res .= str_pad(base_convert( $part, 16, 2), 16, 0, STR_PAD_LEFT);
        return $res;
    }

    /**
    *   MatchCIDR6 -- Check if an ipv6 address is in the CDIR6 subnet.
    *   @param string $cidr6 - an ipv6 subnet, ex 2001:288:5400/39 or 2001:288:5432:/64.
    *   @param string $chkipv6 - an ipv6 address, ex ::1, 2001:288:5200::1, :: ,etc.
    *   @return return true if $chkipv6 is inside the $cidr6 subnet, or return false.
    */
    public function MatchCIDR6( $cidr6, $chkipv6)
    {
        list($ip6, $prefixlen) = explode('/', $cidr6);
        $cidrbin= substr( $this->ExpandIPv6Notation2Bin($ip6), 0, $prefixlen);
        $chkip6bin= substr( $this->ExpandIPv6Notation2Bin($chkipv6), 0, $prefixlen);
        if(! strcmp($cidrbin,$chkip6bin))return true;
        return false;
    }
}


